@echo off

if exist XSET.EXE goto OK_to_go
echo You must be in the directory containing XSET
goto end

:OK_to_go
if "%1" == "second_time" goto begin

:: Run a new shell with environment big enough (10,000 bytes to be sure)

:: run a new command.com with more environment space
command /e:10000/c %0 second_time
goto end    

:begin
XSET /FILE %0 intro
goto HELP
[intro]
/BACKGROUND blue /COLOR white/CLS
               /PROMPT"            ͻ"
/XPOS 1/YPOS +1/PROMPT"                                                             "
/XPOS 1/YPOS +1/PROMPT"                  Welcome to XSET demo     "
/XPOS 1/YPOS +1/PROMPT"                                                             " 
/XPOS 1/YPOS +1/PROMPT"            ͼ"
                                                                                       
/XPOS 1/YPOS +2/PROMPT"  Hello,"
/XPOS 1/YPOS +3/PROMPT"  Although you always thought you cannot perform real programming with  DOS"
/XPOS 1/YPOS +1/PROMPT"  batch files, this demo will show you it is feasible; furthermore, it will"
/XPOS 1/YPOS +1/PROMPT"  show you it is very easy to do."

/XPOS 1/YPOS +2/PROMPT"  What really lacks in DOS is a way to handle environment variables."
/XPOS 1/YPOS +1/PROMPT"  The only thing DOS allows you to do is to assign a variable to a value"
/XPOS 1/YPOS +1/PROMPT"  and to use its value."

/XPOS 1/YPOS +2/PROMPT"  Did you ever dream to get a user's answer into an environment variable,"
/XPOS 1/YPOS +1/PROMPT"  or the result of a calculation, or the output of a program ?"
/XPOS 1/YPOS +1/PROMPT"  Did you ever try to find a way to write  a batch file  that will allow"
/XPOS 1/YPOS +1/PROMPT"  a selective  behaviour  for different configurations  (like  different"
/XPOS 1/YPOS +1/PROMPT"  processor types or day of the week,...) ?"

/YPOS 24 /XPOS 55 /COLOR yellow /BLINK /PROMPT "Hit any key to continue" /-BLINK _xtmp KEY

/BACKGROUND blue /COLOR white/CLS
               /PROMPT"  So, why do YOU need XSET ?"

/XPOS 1/YPOS +2/PROMPT"  1. Because you are PC support (like me) and often  have to write batch files"
/XPOS 1/YPOS +1/PROMPT"     that will  be used  by a great  number  of people  and  they must be very"
/XPOS 1/YPOS +1/PROMPT"     context-dependant and highly interactive (especially if users do not know"
/XPOS 1/YPOS +1/PROMPT"     about DOS and they panic if they see 'Abort, Retry, Fail?')."

/XPOS 1/YPOS +2/PROMPT"  2. Because you need to work in different environments  ( for example you are"
/XPOS 1/YPOS +1/PROMPT"     are connected to different networks,  or you swap between two development"
/XPOS 1/YPOS +1/PROMPT"     environment - compilers,... )  and you have to maintain two sets of batch"
/XPOS 1/YPOS +1/PROMPT"     files."

/XPOS 1/YPOS +2/PROMPT"  3. Because you do not like to see your batch files waiting for you the whole"
/XPOS 1/YPOS +1/PROMPT"     night because you forgot to insert a floppy into drive A: and locking the"
/XPOS 1/YPOS +1/PROMPT"     computer instead of running your communication software."

/XPOS 1/YPOS +2/PROMPT"  4. Because you simply want to interactively  edit  your path  ( or any other"
/XPOS 1/YPOS +1/PROMPT"     variable), save all your environment to restore it later,..."
/XPOS 1/YPOS +1/PROMPT"     In other words, you want to have full control of your environment."

/YPOS 24 /XPOS 55 /COLOR yellow /BLINK /PROMPT "Hit any key to continue" /-BLINK _xtmp KEY
 
/BACKGROUND blue /COLOR white/CLS
               /PROMPT" The main goal of XSET is to put ANYTHING YOU WANT into an environment variable"
/XPOS 1/YPOS +1/PROMPT" and to modify it LIKE YOU WANT; it also by-passes the internal limits of plain"
/XPOS 1/YPOS +1/PROMPT" DOS like the 128 characters limit  (very useful if you need a very long path)."
/XPOS 1/YPOS +1/PROMPT" But XSET also provide  a lot of built-in facilities  like  full floating-point"
/XPOS 1/YPOS +1/PROMPT" calculation,  time  and  date handling,  system information (kind of CPU, is a"
/XPOS 1/YPOS +1/PROMPT" disk ready,...), customized prompts (also in color) and much more !!!"        

/XPOS 1/YPOS +2/PROMPT" XSET is fully compatible with MS-DOS, DR-DOS, 4DOS, NDOS, OS/2"
/XPOS 1/YPOS +1/PROMPT" & Windows (3.x, 95, NT)."

/XPOS 1/YPOS +2/PROMPT" XSET is not only the most powerful  environment variables manipulation program"
/XPOS 1/YPOS +1/PROMPT" you ever saw,  but it also has a very easy and intuitive user interface  (very"
/XPOS 1/YPOS +1/PROMPT" close to the DOS 'SET' command)."

/XPOS 1/YPOS +2/PROMPT" Example 1:  to ask the user's name and store the result in a variable 'name'"
/XPOS 1/YPOS +1/PROMPT"    XSET /PROMPT 'Enter your name: ' name"

/XPOS 1/YPOS +2/PROMPT" Example 2:  to store the processor type in a variable 'cpu_kind'"
/XPOS 1/YPOS +1/PROMPT"    XSET cpu_kind CPU"

/XPOS 1/YPOS +2/PROMPT" Example 3:  to extract the 5 firsts characters of a string"
/XPOS 1/YPOS +1/PROMPT"    XSET /LEFT 5 var=any string you want"

/YPOS 24 /XPOS 55 /COLOR yellow /BLINK /PROMPT "Hit any key to continue" /-BLINK _xtmp KEY
[end]

:HELP
XSET /?

XSET /FILE %0 syscheck /FILE %0 menu_init /FILE %0 menu
goto waitkey

[syscheck]
/BACKGROUND blue /COLOR white/CLS
               /PROMPT"  Following is a demo which only goal is to show how powerful XSET is."
/XPOS 1/YPOS +1/PROMPT"  The demo itself is not very useful but it implements a kind of very"
/XPOS 1/YPOS +1/PROMPT"  limited file manager."
/XPOS 1/YPOS +1/PROMPT"  None  of the messages,  colors,  default values or  behaviours  are"
/XPOS 1/YPOS +1/PROMPT"  hard-coded  into the program;  they all are given  as parameters in"
/XPOS 1/YPOS +1/PROMPT"  the batch file."
/XPOS 1/YPOS +1/PROMPT"  XSET is not limited  to this kind of handling;  I only had to choose"
/XPOS 1/YPOS +1/PROMPT"  something that has a great level of interaction because it is better"
/XPOS 1/YPOS +1/PROMPT"  for a demo but the most powerful features of XSET are generally used"
/XPOS 1/YPOS +1/PROMPT"  for non-interactive procedures."

/XPOS 1/YPOS +2/PROMPT"  Note  for people  who have  a monochrome monitor  and  a color video"
/XPOS 1/YPOS +1/PROMPT"  board:  The demo displays messages in color  but you normally should"
/XPOS 1/YPOS +1/PROMPT"  read everything correctly (you even will see highlight)."

/YPOS 24 /XPOS 55 /COLOR yellow /BLINK /PROMPT "Hit any key to continue" /-BLINK _xtmp KEY

/BACKGROUND black /COLOR white/CLS
               /PROMPT"  First of all, some system checks."
/XPOS 1/YPOS +1/PROMPT"  Note that all displayed results are actually stored into an environment"
/XPOS 1/YPOS +1/PROMPT"  variable; the following message could use the normal DOS 'echo' command."

/BOX /BORDER /BACKGROUND red /COLOR white /XPOS 34 /YPOS 6 /PROMPT "System Check"
/-BOX /-BORDER /BACKGROUND black
_xtmp CPU
/YPOS +4 /XPOS 5 /COLOR white /PROMPT "CPU kind:" /XPOS 30 /COLOR lightblue /PROMPT "80%_xtmp%86"
_xtmp DRIVETEST a:
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "Drive a:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
_xtmp DRIVETEST c:
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "Drive c:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
_xtmp DRIVETEST d:
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "Drive d:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
_xtmp DRIVETEST x:
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "Drive x:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
_xtmp TIME
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "Time:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
/*CHANGE "$" "\" /*CHANGE "\\$" "\" _xtmp DIR c:
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "Current dir  of drive C:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
_xtmp VOLLABEL c:
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "Volume label of drive C:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
_xtmp BYTEFREE c:
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "Bytes free   on drive C:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
_xtmp FSIZE c:\autoexec.bat
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "autoexec.bat size:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
_xtmp FDATE c:\autoexec.bat
/YPOS +1 /XPOS 5 /COLOR white /PROMPT "autoexec.bat date:" /XPOS 30 /COLOR lightblue /PROMPT "%_xtmp%"
/YPOS 24 /XPOS 55 /COLOR yellow /BLINK /PROMPT "Hit any key to continue" /-BLINK _xtmp KEY

[menu_init]
_xdrive FDRIVE *
_xdrstatus DRIVETEST %_xdrive%
# because path must be set to here (if we change the current directory)
/MID 3 100 _xdir FDIR *
path=%_xdrive%%_xdir%;%path%
_xfile=*.*
_xoptions=/P
_xdate DATE
_xpos=3

[MENU]
/BACKGROUND black /CLS   
/BACKGROUND blue /COLOR yellow /BORDER /WINDOW 3 1 75 17
/XPOS 5 /YPOS 2 /PROMPT "    X S E T:  Menu example    "
/XPOS 7 /YPOS 5  /COLOR lightred /PROMPT "D" /COLOR white /PROMPT " Drive    :"
/XPOS 7 /YPOS +1 /COLOR lightred /PROMPT "P" /COLOR white /PROMPT " Path     :"
/XPOS 7 /YPOS +1 /COLOR lightred /PROMPT "F" /COLOR white /PROMPT " FileSpec :"
/XPOS 7 /YPOS +1 /COLOR lightred /PROMPT "O" /COLOR white /PROMPT " Options  :"
/COLOR white /XPOS 5 /YPOS +2 /PROMPT ""
/XPOS 27 /YPOS +2 /COLOR lightred /PROMPT "1" /COLOR white /PROMPT " List directory contents"
/XPOS 27 /YPOS +1 /COLOR lightred /PROMPT "2" /COLOR white /PROMPT " List File contents"
/XPOS 27 /YPOS +2 /COLOR lightred /PROMPT "Q" /COLOR white /PROMPT " Quit menu"
/XPOS 60 /YPOS 4 /COLOR green /PROMPT "%_xdate%"
_xtmp DATE hh:mm
/XPOS 63 /YPOS 6 /COLOR green /PROMPT "%_xtmp%"
/COLOR lightgray
/XPOS 20 /YPOS 5  /PROMPT "%_xdrive% (%_xdrstatus%)"
/MID 3 100 _xdir FDIR *
/XPOS 20 /YPOS +1 /PROMPT "%_xdir%"
/XPOS 20 /YPOS +1 /PROMPT "%_xfile%"    
/XPOS 20 /YPOS +1 /PROMPT "%_xoptions%"  
/XPOS %_xpos% /YPOS 20 /BACKGROUND black /COLOR magenta /PROMPT "Type a key to make a choice (1,2,D,P,F,O,Q)"
/UPPER _xkey KEY "12DPFOQ"
[END]

:menu
XSET /FILE %0 menu
   
:: *** Jump here after an option, if you do not have to redraw the screen
:waitkey
goto menu%_xkey%

:: *** CHOICE 1: List the directory contents
:menu1 
cls             
dir %_xoptions% %_xdrive%%_xdir%%_xfile%
pause
goto menu

:: *** CHOICE 2: List a file
:menu2
XSET/UPPER _xtmp FPATH %_xdrive%%_xdir%%_xfile%
XSET/UPPER/XPOS %_xpos%/COLOR HIGHLIGHT/PROMPT"Filename: "/DEFAULT _xtmp
if exist %_xtmp% goto fexist
XSET/XPOS %_xpos%/BLINK/COLOR RED/PROMPT"Error: File does not exist."
pause
goto menu                   
:fexist              
:: Test for wildcards
XSET _xtmp2 FXNAME %_xtmp%
XSET _xtmp3 FDIR %_xtmp%
for %%f in (%_xtmp3%%_xtmp2%) do set _xtmp3=%%f
if "%_xtmp%" == "%_xtmp3%" goto listf
XSET/XPOS %_xpos%/BLINK/COLOR RED/PROMT"Error: Only one file may be specified."
pause
goto menu                   
:listf
more < %_xtmp%
pause
goto menu

:: *** CHOICE D: Change drive
:menuD
XSET/XPOS %_xpos%/COLOR YELLOW/PROMPT"Choose a drive (A-Z)"/UPPER _xtmp KEY "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
xset _xtmp2 DRIVETEST %_xtmp% 
XSET/SEARCH "READABLE" _xtmp3=%_xtmp2%
if not "%_xtmp3%" == "" goto chdrv
XSET/XPOS %_xpos%/BLINK/COLOR RED/PROMPT"Error - drive %_xtmp% status: = %_xdrstatus%"
pause
goto menu
:chdrv                           
set _xdrive=%_xtmp%:
set _xdrstatus=%_xtmp2%
%_xdrive%
:: Get current directory
goto menu

:: *** CHOICE P: Change directory
:menuP                   
set _xtmp=%_xdir%
echo:
echo:
XSET/XPOS %_xpos%/BORDER/PROMPT "New directory: "/DEFAULT _xtmp
XSET/SEARCH ":" _xtmp2 VARCOPY _xtmp
if not "%_xtmp2%" == "" goto menuP
:: remove trailing \ (if any)
XSET/*CHANGE "\\$" "" _xtmp="%_xtmp%"
:: check if directory exist
if not exist %_xtmp%\*.* if not exist %_xtmp%\nul goto chdirError
cd %_xtmp%
::XSET _xdir FPATH %_xtmp%
::cd %_xdir% 
::set _xdir=%_xdir%\
goto menu
:chdirError 
XSET/XPOS %_xpos%/BLINK/COLOR RED/PROMPT"Error: Directory not existing."
pause
goto menu

:: *** CHOICE F: Filename
:menuF                   
set _xtmp=%_xfile%
XSET/XPOS %_xpos%/COLOR LIGHTBLUE/PROMPT"FileSpec: "/DEFAULT _xtmp
XSET/SEARCH ":" _xtmp2 VARCOPY _xtmp
if not "%_xtmp2%" == "" goto menuF
XSET/SEARCH "\" _xtmp2 VARCOPY _xtmp
if not "%_xtmp2%" == "" goto menuF
XSET _xfile VARCOPY _xtmp
goto menu

:: *** CHOICE O: Options
:menuO
XSET/XPOS %_xpos%/COLOR GREEN/PROMPT"Dir options: "/DEFAULT _xoptions
goto menu
      
:menuQ 
:end     
