@echo off
                  
if exist XSET.EXE goto OK_to_go
echo You must be in the directory containing XSET
goto end

:OK_to_go
if "%1" == "second_time" goto begin

:: Run a new shell with environment big enough (10,000 bytes to be sure)
command/e:10000/c demo.bat second_time
goto end
    
:begin
     
cls
echo            ͻ  
echo                                                             
echo                  Welcome to XSET demo     
echo                                                              
echo            ͼ
echo: 
echo  This is a simplified version of DEMO.BAT (which is more efficient
echo  but also more complex).
echo  First look to this batch file before trying to read DEMO.BAT.
echo:
echo:

XSET _xtmp CPU                
echo  CPU kind:                  80%_xtmp%86
                                     
:: the following trick would be useless if the 'FOR' command
:: would allow to perform several actions in a loop
:: (so we create and call a batch file)
echo XSET _xtmp DRIVETEST %%1 > _xtmp.bat
echo echo  drive %%1: status:           %%_xtmp%% >> _xtmp.bat
for %%d in (A C D X) do call _xtmp.bat %%d
del _xtmp.bat
    
XSET _xtmp TIME
echo  Current time:              %_xtmp%
                                     
XSET _xtmp DIR c:
echo  current dir  of drive C:   \%_xtmp%
                                     
XSET _xtmp VOLLABEL c:
echo  volume label of drive C:   %_xtmp%
                                     
XSET _xtmp BYTEFREE c:
echo  bytes free   on drive C:   %_xtmp%
                                     
XSET _xtmp FDATE c:\autoexec.bat
echo  c:\autoexec.bat - date:    %_xtmp%
                                     
XSET _xtmp FSIZE c:\autoexec.bat
echo  c:\autoexec.bat - size:    %_xtmp%
               
echo:
echo:                      
pause          

:: ----------------------------------------------------- 
:demo
     
:: Ŀ                         
:: Get current drive & path into environment                             
::                              
XSET _xdrive FDRIVE *                                                    
XSET/MID 3 100 _xdir FDIR *                                              
                                                                         
:: Ŀ
::  Store current path & add this directory to it
:: 
XSET _xpath VARCOPY path
set path=%_xdrive%%_xdir%;
XSET/APPEND path varcopy _xpath
 
:: Ŀ
:: Set default values
:: 
set _xfile=*.*
set _xoptions=/P
       
XSET _xdate DATE                                                                  
set _xpos=3
          
::  Show menu on Screen Ŀ
::                                                                       
::  This is purely examplative Ĵ
::  Experiment with dir, changing drive path options, ... Ĵ
:: 
:menu
cls   
set XSET=/BACKGROUND BLUE/COLOR YELLOW/WINDOW 3 1 75 17/BORDER
XSET/XPOS 5/YPOS 2/PROMPT "    X S E T:  Menu example    "
set XSET=/BACKGROUND BLUE/COLOR WHITE/XPOS 7
XSET/YPOS 5/PROMPT"D Drive    :"
XSET/PROMPT "P Path     :"
XSET/PROMPT "F FileSpec :"
XSET/PROMPT "O Options  :"
echo:
XSET/XPOS 5/PROMPT""
echo:
set XSET=/BACKGROUND BLUE/COLOR WHITE/XPOS 27
XSET/PROMPT "1  List directory contents"
XSET/PROMPT "2  List File contents"
echo:
XSET/PROMPT "Q  Quit menu"

:: Ŀ
::  Showing drive, path, _xfile and _xoptions Ĵ
:: 
   
XSET/YPOS 4/XPOS 60/COLOR GREEN/PROMPT"%_xdate%"
XSET _xtmp DRIVETEST %_xdrive%
set _xtmp=%_xdrive% (%_xtmp%)
set XSET=/BACKGROUND BLUE/COLOR LIGHTGRAY/XPOS 20
XSET/YPOS 5/PROMPT"%_xtmp%"
XSET/PROMPT "%_xdir%"
XSET/PROMPT "%_xfile%"    
XSET/PROMPT "%_xoptions%"  

set XSET=/XPOS %_xpos%/YPOS 20
XSET/UPPER/COLOR MAGENTA/PROMPT"Type a key to make a choice (1,2,3,D,P,F,O,Q)" _xkey KEY "123DPFOQ"
set XSET=
   
:: Ŀ
::  Jump here after an option, if you do not have to redraw the screen Ĵ
:: 
:waitkey

goto menu%_xkey%

:: Ŀ
::   CHOICE 1: List the directory contents
:: 
:menu1 
cls             
dir %_xoptions% %_xdrive%%_xdir%%_xfile%
pause
goto menu


:: Ŀ
::   CHOICE 2: List a file  
:: 
:menu2
XSET/UPPER _xtmp FPATH %_xdrive%%_xdir%%_xfile%
XSET/UPPER/XPOS %_xpos%/COLOR HIGHLIGHT/PROMPT"Filename: "/DEFAULT _xtmp
if exist %_xtmp% goto fexist
XSET/XPOS %_xpos%/BLINK/COLOR RED/PROMPT"Error: File does not exist."
pause
goto menu                   
:fexist              
:: Test for wildcards
XSET _xtmp2 FXNAME %_xtmp%
XSET _xtmp3 FDIR %_xtmp%
for %%f in (%_xtmp3%%_xtmp2%) do set _xtmp3=%%f
if "%_xtmp%" == "%_xtmp3%" goto listf
XSET/XPOS %_xpos%/BLINK/COLOR RED/PROMT"Error: Only one file may be specified."
pause
goto menu                   
:listf
more < %_xtmp%
pause
goto menu


:: Ŀ
::   CHOICE D: Change drive 
:: 
:menuD
XSET/XPOS %_xpos%/COLOR YELLOW/PROMPT"Choose a drive (A-Z)"/UPPER _xtmp KEY "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
XSET/SEARCH"READABLE" _xtmp2 DRIVETEST %_xtmp%
if not "%_xtmp2%" == "" goto chdrv
xset _xtmp2 DRIVETEST %_xtmp% 
XSET/XPOS %_xpos%/BLINK/COLOR RED/PROMPT"Error - drive status %_xtmp%: = %_xtmp2%"
pause
goto menu
:chdrv                           
set _xdrive=%_xtmp%:
%_xdrive%
:: Get current directory
XSET/MID 3 100 _xdir FDIR *
goto menu


:: Ŀ
::   CHOICE P: Change directory 
:: 
:menuP                   
set _xtmp=%_xdir%
echo:
echo:
XSET/XPOS %_xpos%/BORDER/PROMPT "New directory:"/DEFAULT _xtmp
XSET/SEARCH ":" _xtmp2 VARCOPY _xtmp
if not "%_xtmp2%" == "" goto menuP
:: remove trailing \ (if any)
XSET/*CHANGE "\\$" "" _xtmp="%_xtmp%"
:: check if directory exist
if not exist %_xtmp%\nul goto chdirError
XSET _xdir FPATH %_xtmp%
cd %_xdir% 
set _xdir=%_xdir%\
goto menu
:chdirError 
XSET/XPOS %_xpos%/BLINK/COLOR RED/PROMPT"Error: Directory not existing."
pause
goto menu


:: Ŀ
::   CHOICE F: Filename         
:: 
:menuF                   
set _xtmp=%_xfile%
XSET/XPOS %_xpos%/COLOR LIGHTBLUE/PROMPT"FileSpec: "/DEFAULT _xtmp
XSET/SEARCH ":" _xtmp2 VARCOPY _xtmp
if not "%_xtmp2%" == "" goto menuF
XSET/SEARCH "\" _xtmp2 VARCOPY _xtmp
if not "%_xtmp2%" == "" goto menuF
XSET _xfile VARCOPY _xtmp
goto menu


:: Ŀ
::   CHOICE O: Options          
:: 
:menuO
XSET/XPOS %_xpos%/COLOR GREEN/PROMPT"Dir options: "/DEFAULT _xoptions
goto menu

      
:menuQ 
:end     
